(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.umd = factory());
})(this, (function () { 'use strict';

  function _typeof(obj) {
    "@babel/helpers - typeof";

    return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
      return typeof obj;
    } : function (obj) {
      return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    }, _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }

  function addHTMLSuffix(url) {
    if (typeof url !== 'string') throw new Error('wx.redirectTo: invalid url:' + url);
    var urlArr = url.split('?');
    urlArr[0] += '.html';
    return typeof urlArr[1] !== 'undefined' ? urlArr[0] + '?' + urlArr[1] : urlArr[0];
  }

  function getRealRoute(pathname, url) {
    var isHtml = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    if (!pathname) return url;
    isHtml && (url = isHtml ? addHTMLSuffix(url) : url);
    if (url.indexOf('/') === 0) return url.substr(1);
    if (url.indexOf('./') === 0) return getRealRoute(pathname, url.substr(2), !1);
    var index;
    var urlArrLength;
    var urlArr = url.split('/');

    for (index = 0, urlArrLength = urlArr.length; index < urlArrLength && urlArr[index] === '..'; index++) {
    }

    urlArr.splice(0, index);
    var pathArr = pathname.length > 0 ? pathname.split('/') : [];
    pathArr.splice(pathArr.length - index - 1, index + 1);
    var newPathArr = pathArr.concat(urlArr);
    return newPathArr.join('/');
  }
  var encodeUrlQuery = function encodeUrlQuery(url) {
    // 把url中的参数encode
    if (typeof url === 'string') {
      var urlArr = url.split('?');
      var urlPath = urlArr[0];
      var queryParams = (urlArr[1] || '').split('&').reduce(function (res, cur) {
        if (typeof cur === 'string' && cur.length > 0) {
          var curArr = cur.split('=');
          var key = curArr[0];
          var value = curArr[1];
          res[key] = value;
        }

        return res;
      }, {});
      var urlQueryArr = [];

      for (var i in queryParams) {
        Object.prototype.hasOwnProperty.call(queryParams, i) && urlQueryArr.push(i + '=' + encodeURIComponent(queryParams[i]));
      }

      return urlQueryArr.length > 0 ? urlPath + '?' + urlQueryArr.join('&') : url;
    }

    return url;
  };
  var getDataType = function getDataType(data) {
    // get data type
    return Object.prototype.toString.call(data).split(' ')[1].split(']')[0];
  };
  var convertObjectValueToString = function convertObjectValueToString(obj) {
    // 把对象元素都转成字符串
    return Object.keys(obj).reduce(function (res, cur) {
      typeof obj[cur] === 'string' ? res[cur] = obj[cur] : typeof obj[cur] === 'number' ? res[cur] = obj[cur] + '' : res[cur] = Object.prototype.toString.apply(obj[cur]);
      return res;
    }, {});
  };
  function urlEncodeFormData(data, needEncode) {
    // 把对象生成queryString
    if (_typeof(data) !== 'object') return data;
    var tmpArr = [];

    for (var o in data) {
      if (Object.prototype.hasOwnProperty.call(data, o)) {
        if (needEncode) {
          try {
            tmpArr.push(encodeURIComponent(o) + '=' + encodeURIComponent(data[o]));
          } catch (t) {
            tmpArr.push(o + '=' + data[o]);
          }
        } else tmpArr.push(o + '=' + data[o]);
      }
    }

    return tmpArr.join('&');
  }
  var addQueryStringToUrl = function addQueryStringToUrl(originalUrl, newParams, needEncode) {
    // 生成url t:param obj
    if (typeof originalUrl === 'string' && _typeof(newParams) === 'object' && newParams) {
      var urlComponents = originalUrl.split('?');
      var host = urlComponents[0];
      var oldParams = (urlComponents[1] || '').split('&').reduce(function (res, cur) {
        if (typeof cur === 'string' && cur.length > 0) {
          var curArr = cur.split('=');
          var key = curArr[0];
          var value = curArr[1];
          res[key] = value;
        }

        return res;
      }, {});
      var refinedNewParams = Object.keys(newParams).reduce(function (res, cur) {
        _typeof(newParams[cur]) === 'object' ? res[encodeURIComponent(cur)] = encodeURIComponent(JSON.stringify(newParams[cur])) : res[encodeURIComponent(cur)] = encodeURIComponent(newParams[cur]);
        return res;
      }, {});
      var formData = urlEncodeFormData(Object.assign(oldParams, refinedNewParams), needEncode);

      if (formData) {
        return host + '?' + formData;
      }

      return host;
    }

    return originalUrl;
  };
  var base64ToArrayBuffer = function base64ToArrayBuffer(str) {
    var atobStr = atob(str);
    var leng = atobStr.length;
    var arr = new Uint8Array(leng);

    for (var r = 0; r < leng; r++) {
      arr[r] = atobStr.charCodeAt(r);
    }

    return arr.buffer;
  };
  var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
  var atob = window.atob || function (input) {
    var str = String(input).replace(/[=]+$/, ''); // #31: ExtendScript bad parse of /=

    if (str.length % 4 === 1) {
      throw new InvalidCharacterError('\'atob\' failed: The string to be decoded is not correctly encoded.');
    }

    var bc = 0;
    var bs;
    var buffer;
    var idx = 0;
    var output = '';

    for (; buffer = str.charAt(idx++); // eslint-disable-line no-cond-assign
    // character found in table? initialize bit storage and add its ascii value;
    ~buffer && (bs = bc % 4 ? bs * 64 + buffer : buffer, // and if not first of each 4 characters,
    // convert the first 8 bits to one ascii character
    bc++ % 4) ? output += String.fromCharCode(255 & bs >> (-2 * bc & 6)) : 0) {
      // try to find character in table (0-63, not found => -1)
      buffer = chars.indexOf(buffer);
    }

    return output;
  };

  var userAgent = window.navigator.userAgent; // const isAndroid = userAgent.indexOf('Android') !== -1;

  var isIOS = (userAgent.indexOf('iPhone') !== -1 || userAgent.indexOf('iPad') !== -1) && !window.isIDE;
  var isWin = userAgent.indexOf('Windows') !== -1 && !window.isIDE;
  var isWeb = window.self !== window.top; // invoke callbacks

  var callbacks = {};
  var callbackIndex = 0; // subscribe handlers

  var handlers = {};
  var eventPrefix = 'custom_event_';

  var invokeHandler = function invokeHandler(event, paramsString, callbackId) {
    if (isIOS) {
      window.webkit.messageHandlers.webInvokeHandler.postMessage({
        C: event,
        paramsString: paramsString,
        callbackId: callbackId
      });
    } else if (isWin) {
      var payload = {
        C: event,
        paramsString: paramsString,
        callbackId: callbackId,
        type: 'invoke'
      };
      window.FinClipExecuteCommandAsync({
        request: JSON.stringify(payload),
        persistent: false,
        onSuccess: function onSuccess() {},
        onFailure: function onFailure() {}
      });
    } else if (isWeb) {
      var _payload = {
        C: event,
        paramsString: paramsString,
        callbackId: callbackId,
        from: 'webview',
        type: 'invoke'
      };
      if (!window.parent) return;
      var jsCoreHandleResult = window.parent.postMessage(_payload, '*');

      if (typeof jsCoreHandleResult !== 'undefined' && typeof callbacks[callbackId] === 'function' && jsCoreHandleResult !== '') {
        try {
          jsCoreHandleResult = JSON.parse(jsCoreHandleResult);
        } catch (e) {
          jsCoreHandleResult = {};
        }

        callbacks[callbackId](jsCoreHandleResult);
        delete callbacks[callbackId];
      }
    } else {
      var _jsCoreHandleResult = FinChatJSCore.webInvokeHandler(event, paramsString, callbackId);

      if (typeof _jsCoreHandleResult !== 'undefined' && typeof callbacks[callbackId] === 'function' && _jsCoreHandleResult !== '') {
        try {
          _jsCoreHandleResult = JSON.parse(_jsCoreHandleResult);
        } catch (e) {
          _jsCoreHandleResult = {};
        }

        callbacks[callbackId](_jsCoreHandleResult);
        delete callbacks[callbackId];
      }
    }
  };

  var invoke = function invoke(event, params, callback) {
    // postMessage
    var paramsString = JSON.stringify(params || {});
    var callbackId = ++callbackIndex;
    callbacks[callbackId] = callback;
    invokeHandler(event, paramsString, callbackId);
  };

  var webInvokeCallbackHandler = function webInvokeCallbackHandler(callbackId, params) {
    var callback = callbacks[callbackId];

    for (var i = 0; i < window.frames.length; i++) {
      window.frames[i].postMessage(JSON.stringify({
        callbackId: callbackId,
        params: params
      }), '*');
    }

    if (typeof callback === 'function') callback(params);
    delete callbacks[callbackId];
  };

  var webSubscribe = function webSubscribe(eventName, handler) {
    handlers[eventName] = handler;
  };

  var subscribe = function subscribe(eventName, handler) {
    handlers[eventPrefix + eventName] = handler;
  };

  var subscribeHandler = function subscribeHandler(eventName, data, webviewId, reportParams) {
    // 执行注册的回调
    console.log('subscribeHandler', eventName);
    var handler = handlers[eventName];

    if (typeof handler === 'function') {
      return handler(data, webviewId, reportParams);
    }
  };

  var publish = function publish(eventName, params, webviewIds) {
    console.log(eventName, params, webviewIds); // publishHandler

    webviewIds = webviewIds || [];
    var paramsString = '';
    var event = eventName;
    paramsString = JSON.stringify(params);
    webviewIds = JSON.stringify(webviewIds);
    publishHandler(event, paramsString, webviewIds);
  };

  var publishHandler = function publishHandler(event, paramsString, webviewIds) {
    // publishHandler
    if (isIOS) {
      window.webkit.messageHandlers.publishHandler.postMessage({
        event: event,
        paramsString: paramsString,
        webviewIds: webviewIds
      });
    } else if (isWin) {
      var payload = {
        event: event,
        paramsString: paramsString,
        webviewIds: webviewIds,
        type: 'publish'
      };
      window.FinClipExecuteCommandAsync({
        request: JSON.stringify(payload),
        persistent: false,
        onSuccess: function onSuccess(res) {// _this.callbacks[callbackId](res)
          // delete _this.callbacks[callbackId]
        },
        onFailure: function onFailure(code, msg) {}
      }); // window.chrome.webview.postMessage({
      //   event: event,
      //   paramsString: paramsString,
      //   webviewIds: webviewIds,
      //   type: 'publish',
      // });
    } else if (isWeb) {
      var _payload2 = {
        event: event,
        paramsString: paramsString,
        from: 'webview',
        type: 'publish'
      };

      if (window.parent) {
        window.parent.postMessage(_payload2, '*');
      }
    } else {
      FinChatJSCore.publishHandler(event, paramsString, webviewIds);
    }
  };

  var invokeMethod = function invokeMethod(apiName, opts, innerCb) {
    var options = opts || {};
    var innerFns = innerCb || {};
    var params = {};

    for (var i in options) {
      if (typeof options[i] === 'function') {
        params[i] = options[i];
        delete options[i];
      }
    }

    var sysEventFns = {};

    for (var s in innerFns) {
      if (typeof innerFns[s] === 'function') {
        sysEventFns[s] = innerFns[s];
      }
    }

    invoke(apiName, options, function (res) {
      res.errMsg = res.errMsg || apiName + ':ok';
      var isOk = res.errMsg.indexOf(apiName + ':ok') === 0;
      var isCancel = res.errMsg.indexOf(apiName + ':cancel') === 0;
      var isFail = res.errMsg.indexOf(apiName + ':fail') === 0;

      if (isOk) {
        typeof sysEventFns.beforeAll === 'function' && sysEventFns.beforeAll(res);
        typeof sysEventFns.beforeSuccess === 'function' && sysEventFns.beforeSuccess(res);
        typeof params.success === 'function' && params.success(res);
        typeof sysEventFns.afterSuccess === 'function' && sysEventFns.afterSuccess(res);
      } else if (isCancel) {
        res.errMsg = res.errMsg.replace(apiName + ':cancel', apiName + ':fail cancel');
        typeof params.fail === 'function' && params.fail(res);
        typeof sysEventFns.beforeCancel === 'function' && sysEventFns.beforeCancel(res);
        typeof params.cancel === 'function' && params.cancel(res);
        typeof sysEventFns.afterCancel === 'function' && sysEventFns.afterCancel(res);
      } else if (isFail) {
        typeof sysEventFns.beforeFail === 'function' && sysEventFns.beforeFail(res);
        typeof params.fail === 'function' && params.fail(res);
        typeof sysEventFns.afterFail === 'function' && sysEventFns.afterFail(res);
      }

      typeof params.complete === 'function' && params.complete(res);
      typeof sysEventFns.afterAll === 'function' && sysEventFns.afterAll(res);
    });
  };

  if (isWeb) {
    window.addEventListener('message', function (_ref) {
      var _ref$data = _ref.data,
          data = _ref$data === void 0 ? {} : _ref$data;
      var type = data.type;

      if (type === 'webInvokeCallbackHandler') {
        var callbackId = data.callbackId,
            params = data.params;
        webInvokeCallbackHandler(callbackId, params);
      } else if (type === 'subscribeHandler') {
        var eventName = data.eventName,
            _params = data.params;
        subscribeHandler(eventName, _params);
      }
    });
  }

  window.FinChatJSBridge = {
    invoke: invoke,
    invokeCallbackHandler: webInvokeCallbackHandler,
    webInvokeCallbackHandler: webInvokeCallbackHandler,
    subscribe: subscribe,
    subscribeHandler: subscribeHandler,
    // Mark: 兼容的调用方式
    webSubscribeCallBackHandler: subscribeHandler,
    publish: publish,
    publishHandler: publishHandler,
    webSubscribe: webSubscribe
  };
  var mop_bridge = {
    invoke: invoke,
    invokeCallbackHandler: webInvokeCallbackHandler,
    webInvokeCallbackHandler: webInvokeCallbackHandler,
    subscribe: subscribe,
    subscribeHandler: subscribeHandler,
    // Mark: 兼容的调用方式
    webSubscribeCallBackHandler: subscribeHandler,
    publish: publish,
    publishHandler: publishHandler,
    invokeMethod: invokeMethod,
    webSubscribe: webSubscribe
  };

  /**
   * 这是MOPClient模板 目前仅用于
   * @module mop
   */

  var currentRoute = '';
  var tabBar = null;
  var canNavigateTo = true;
  /**
   * MOPClient类,提供MOP小程序WebView的JSSDK交互功能
   * 代码示例:
   * <code>
   window.fc.miniProgram.navigateBack({
     success: function(res) {
       console.log('navigateBack callback:');
       console.log(res);
       alert(JSON.stringify(res))
     }
   });
   * </code>
   */

  var eventHandlers = [];

  var MOPClient = /*#__PURE__*/function () {
    function MOPClient() {
      _classCallCheck(this, MOPClient);

      console.log('MOPClient');

      try {
        mop_bridge.subscribe('webviewEvent', function (data) {
          eventHandlers.forEach(function (handler) {
            handler(data.data);
          });
        });
        mop_bridge.subscribe('webviewCurrentRoute', function (data) {
          currentRoute = data.route;
          tabBar = data.tabBar;
          canNavigateTo = data.canNavigateTo !== undefined ? data.canNavigateTo : true;
        });
        mop_bridge.publish('onWebviewEvent', {
          key: 'getCurrentRoute'
        });
      } catch (e) {}
    }

    _createClass(MOPClient, [{
      key: "checkUrl",
      value: function checkUrl(apiName, params) {
        // Mark: 未实现传递 tabbar 的情况不校验
        if (tabBar === null) {
          return true;
        }

        if (params.url.startsWith('/')) {
          params.url = params.url.slice(1);
        }

        if ((apiName === 'redirectTo' || apiName === 'navigateTo') && tabBar && tabBar.list.find(function (e) {
          return params.url.indexOf(e.pagePath) === 0;
        })) {
          console.error(apiName, params, apiName + ":can not ".concat(apiName, " to a tabbar page"));
          return false;
        } else if (apiName === 'switchTab') {
          if (!tabBar || !tabBar.list.find(function (e) {
            return params.url.indexOf(e.pagePath) === 0;
          })) {
            console.error(apiName, params, apiName + ':fail can not switch to no-tabBar page');
            return false;
          }
        }

        return true;
      }
      /**
       * 关闭当前页面，返回上一页面或多级页面。
       * @param {Object} params {
       *  delta: 1,
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "navigateBack",
      value: function navigateBack() {
        var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var data = params || {};
        data.name = 'navigateBack';
        data.arg = {
          delta: params.delta || 1
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 保留当前页面，跳转到应用内的某个页面。但是不能跳到 tabbar 页面。
       * @param {Object} params {
       *  url: '',
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "navigateTo",
      value: function navigateTo(params) {
        var data = params || {};

        if (!canNavigateTo) {
          if (params.fail && typeof params.fail === 'function') {
            params.fail({
              errMsg: 'navigateTo:fail webview count limit exceed'
            });
          }

          return;
        }

        if (!params.url) {
          throw new Error('Invalid parameter url');
        }

        params.url = getRealRoute(currentRoute, params.url);
        params.url = encodeUrlQuery(params.url);
        data.name = 'navigateTo';
        data.arg = {
          url: params.url || ''
        };

        if (this.checkUrl(data.name, data.arg)) {
          mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
        }
      }
      /**
       * 关闭当前页面，跳转到应用内的某个页面。但是不允许跳转到 tabbar 页面。
       * @param {Object} params {
       *  url: '',
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "redirectTo",
      value: function redirectTo(params) {
        var data = params || {};

        if (!params.url) {
          throw new Error('Invalid parameter url');
        }

        params.url = getRealRoute(currentRoute, params.url);
        params.url = encodeUrlQuery(params.url);
        data.name = 'redirectTo';
        data.arg = {
          url: params.url || ''
        };

        if (this.checkUrl(data.name, data.arg)) {
          mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
        }
      }
      /**
       * 跳转到 tabBar 页面，并关闭其他所有非 tabBar 页面。
       * @param {Object} params {
       *  url: '',
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "switchTab",
      value: function switchTab(params) {
        var data = params || {};

        if (!params.url) {
          throw new Error('Invalid parameter url');
        }

        params.url = getRealRoute(currentRoute, params.url);
        params.url = encodeUrlQuery(params.url);
        data.name = 'switchTab';
        data.arg = {
          url: params.url || ''
        };

        if (this.checkUrl(data.name, data.arg)) {
          mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
        }
      }
      /**
       * 关闭所有页面，打开到应用内的某个页面
       * @param {Object} params {
       *  url: '',
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "reLaunch",
      value: function reLaunch(params) {
        var data = params || {};

        if (!params.url) {
          throw new Error('Invalid parameter url');
        }

        params.url = getRealRoute(currentRoute, params.url);
        params.url = encodeUrlQuery(params.url);
        data.name = 'reLaunch';
        data.arg = {
          url: params.url || ''
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 发送消息
       * @param {Object} params {
       *  data: '',
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "postMessage",
      value: function postMessage(params) {
        var data = params || {};
        data.name = 'postMessage';
        data.arg = params.data || {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 取当前运行环境
       * @param {Object} params {
       *  success: function(res) {}
       * }
       */

    }, {
      key: "getEnv",
      value: function getEnv(params) {
        if (params && _typeof(params) === 'object' && typeof params.success === 'function') {
          params.success({
            env: window.__fcjs_environment || {}
          });
        } else if (typeof params === 'function') {
          params({
            env: window.__fcjs_environment || {}
          });
        } else {
          console.log('params invalid');
        }
      }
      /**
       * 下载文件
       * @param {Object} params {
       *  url: '',
       *  header: '',
       *  timeout: 3000,
       *  filePath: ''
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "downloadFile",
      value: function downloadFile(params) {
        var data = params || {};
        data.name = 'downloadFile';
        data.arg = {
          url: params.url,
          header: params.header,
          timeout: params.timeout,
          filePath: params.filePath
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 打开文件，预览文件
       * @param {*} params {
       *  fileType: 'pdf',
       *  filePath: ''
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "openDocument",
      value: function openDocument(params) {
        var data = params || {};
        data.name = 'openDocument';
        data.arg = {
          filePath: params.filePath,
          fileType: params.fileType
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 选择图片
       * @param {*} params {
       * count: 1, // 默认9
       * sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
       * sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "chooseImage",
      value: function chooseImage(params) {
        var data = params || {};
        data.name = 'chooseImage';
        data.arg = {
          count: params.count || 9,
          sizeType: params.sizeType || ['original', 'compressed'],
          sourceType: params.sourceType || ['album', 'camera']
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 获取本地图片 base64
       * @param {*} params
       * path: 本地图片路径
       */

    }, {
      key: "getLocalImgData",
      value: function getLocalImgData(params) {
        var data = params || {};
        data.name = 'getLocalImgData';
        data.arg = {
          path: params.path
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 获取小程序信息
       * @param {callback} cb function(res) {}
       */

    }, {
      key: "getAppletInfo",
      value: function getAppletInfo(params) {
        var data = params || {};
        data.name = 'getAppletInfo';
        data.arg = {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 关闭小程序
       */

    }, {
      key: "close",
      value: function close(params) {
        var data = params || {};
        data.name = 'close';
        data.arg = {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 小程序跳转
       * @param {*} params {
       * appId: string, // 要打开的小程序 appId
       * path: string, //打开的页面路径
       * extraData: Object, // 需要传递给目标小程序的数据,App.onLaunch，App.onShow 中获取到这份数据
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "navigateToMiniProgram",
      value: function navigateToMiniProgram(params) {
        var data = params || {};
        data.name = 'navigateToMiniProgram';
        data.arg = {
          appId: params.appId,
          path: params.path,
          extraData: params.extraData
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 返回上一个小程序
       * @param {*} params {
       * extraData: Object, // 需要传递给目标小程序的数据,App.onLaunch，App.onShow 中获取到这份数据
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "navigateBackMiniProgram",
      value: function navigateBackMiniProgram(params) {
        var data = params || {};
        data.name = 'navigateBackMiniProgram';
        data.arg = {
          extraData: params.extraData
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 判断 H5 是否能返回上一页
       * @param {Object} params
       */

    }, {
      key: "canGoBack",
      value: function canGoBack(params) {
        var data = params || {};
        data.name = 'canGoBack';
        data.arg = {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
      * 判断小程序页面是否能返回上一页
      * @param {Object} params
      */

    }, {
      key: "canNavigateBack",
      value: function canNavigateBack(params) {
        var data = params || {};
        data.name = 'canNavigateBack';
        data.arg = {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
      * webview 页面设置 navigation title
      * @param {Object} params
      *   title: String
      * }
      */

    }, {
      key: "setNavigationBarTitle",
      value: function setNavigationBarTitle(params) {
        var data = params || {};
        data.name = 'setNavigationBarTitle';
        data.arg = {
          title: String(params.title || '')
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * @description 获取本地缓存
       * @param {Object} params
       * @param {String} params.key
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       */

    }, {
      key: "getStorage",
      value: function getStorage(params) {
        if (typeof params.key !== 'string') {
          throw new Error('Invalid parameter key');
        }

        var data = params || {};
        data.name = 'getStorage';
        data.arg = {
          key: params.key
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data, {
          beforeSuccess: function beforeSuccess(res) {
            if (typeof res.data === 'string') {
              try {
                var result = JSON.parse(res.data);

                if (result._type) {
                  res.data = result.data;
                } else {
                  res.data = result;
                }

                if (result._type === 'Date') {
                  res.data = new Date(res.data);
                }
              } catch (error) {}
            }

            return res;
          }
        });
      }
      /**
       * @description 获取本地缓存的数据
       * @param {Object} params
       * @param {String} params.key
       * @param {String} params.data
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       */

    }, {
      key: "setStorage",
      value: function setStorage(params) {
        if (typeof params.key !== 'string') {
          console.error('parameters error');
          return;
        }

        var _type = _typeof(params.data);

        if (params.data instanceof Date) {
          _type = 'Date';
        }

        try {
          params.data = JSON.stringify({
            data: params.data,
            _type: _type
          });
        } catch (error) {
          console.error('parameters data error');
          return;
        }

        var data = params || {};
        data.name = 'setStorage';
        data.arg = {
          key: params.key,
          data: params.data
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * @description 移除本地缓存
       * @param {Object} params
       * @param {String} params.key
       * success: function(res) {},
       * fail: function(res) {},
       * complete: function(res) {},
       */

    }, {
      key: "removeStorage",
      value: function removeStorage(params) {
        if (typeof params.key !== 'string') {
          console.error('parameters error');
          return;
        }

        var data = params || {};
        data.name = 'removeStorage';
        data.arg = {
          key: params.key
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * @description 清除所有的缓存
       * success: function(res) {},
       * fail: function(res) {},
       * complete: function(res) {},
       */

    }, {
      key: "clearStorage",
      value: function clearStorage(params) {
        var data = params || {};
        data.name = 'clearStorage';
        data.arg = {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * @description 获取储存的信息
       * success: function(res) {},
       * fail: function(res) {},
       * complete: function(res) {},
       */

    }, {
      key: "getStorageInfo",
      value: function getStorageInfo(params) {
        var data = params || {};
        data.name = 'getStorageInfo';
        data.arg = {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 调用app原生接口
       * @param {*} params {
       *  name: String, // 原生APP方法，命名规范，加【 user_define_ 】前缀
       *  data: Object, // 需要传递给原生APP的数据
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */

    }, {
      key: "callHandler",
      value: function callHandler(params) {
        var data = params || {};
        mop_bridge.invokeMethod(params.name, data);
      }
      /**
       * @description 获取当前地理位置信息
       * @param {Object} params
       * @param {String}  params.type 目前不管该参数如何，都会返回gcj02坐标
       * @param {Boolean}  params.altitude 传入 true 会返回高度信息，由于获取高度需要较高精确度，会减慢接口返回速度
       */

    }, {
      key: "getLocation",
      value: function getLocation(params) {
        var data = params || {};
        data.name = 'getLocation';
        data.arg = {
          type: params.type,
          altitude: params.altitude
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * @description 打开地图位置
       * @param {Object} params
       * @param {Number} params.latitude 目标地纬度
       * @param {Number} params.longitude 目标地经度
       */

    }, {
      key: "chooseLocation",
      value: function chooseLocation(params) {
        var data = params || {};
        data.name = 'chooseLocation';
        data.arg = {
          latitude: params.latitude,
          longitude: params.longitude
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
      * @description 请求 api
      * @param {Object}} params
      */

    }, {
      key: "request",
      value: function request() {
        var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        if (!params.url || typeof params.url !== 'string') {
          throw new Error('Invalid parameter url');
        }

        var headerType = getDataType(params.header);
        params.header = params.header || {};
        params.header = convertObjectValueToString(params.header);

        if (headerType !== 'Undefined' && headerType !== 'Object') {
          console.warn('request: header must be an object');
          params.header = {};
        }

        params.header = Object.keys(params.header).reduce(function (res, cur) {
          cur.toLowerCase() === 'content-type' ? res[cur.toLowerCase()] = params.header[cur] : res[cur] = params.header[cur];
          return res;
        }, {});
        params.method && (params.method = params.method.toUpperCase());
        var headers = params.header || {};
        var requestMethod = typeof params.method === 'string' ? params.method.toUpperCase() : 'GET';
        var data = '';
        params.dataType = params.dataType || 'json';
        headers['content-type'] = headers['content-type'] || 'application/json';
        data = !params.data ? '' : typeof params.data !== 'string' ? headers['content-type'].indexOf('application/x-www-form-urlencoded') > -1 ? urlEncodeFormData(params.data, !0) : headers['content-type'].indexOf('application/json') > -1 ? JSON.stringify(params.data) : _typeof(params.data) === 'object' ? JSON.stringify(params.data) : data.toString() : params.data;

        if (requestMethod === 'GET') {
          params.url = addQueryStringToUrl(params.url, params.data);
        }

        mop_bridge.invokeMethod('invokeMiniProgramAPI', {
          name: 'request',
          arg: {
            url: params.url,
            data: data,
            header: headers,
            method: requestMethod,
            dataType: params.dataType || 'json',
            responseType: params.responseType,
            taskId: String(Math.random())
          },
          success: params.success,
          fail: params.fail,
          complete: params.complete
        }, {
          beforeSuccess: function beforeSuccess(res) {
            if (res.isBase64) {
              if (params.responseType && params.responseType.toLowerCase() === 'arraybuffer') {
                res.data = base64ToArrayBuffer(res.data);
              } else {
                res.data = atob(res.data);
              }
            }

            if (params.dataType === 'json') {
              try {
                res.data = JSON.parse(res.data);
              } catch (e) {}
            }

            res.statusCode = parseInt(res.statusCode);
          }
        });
      }
    }, {
      key: "getSuperviseInfo",
      value: function getSuperviseInfo(params) {
        var data = params || {};
        data.name = 'getSuperviseInfo';
        data.arg = {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      }
      /**
       * 注册小程序onShow时回调
       * @param {*} params {
       *
       * }
       */

    }, {
      key: "onShow",
      value: function onShow(params) {
        var data = params || {};
        mop_bridge.subscribe('pageonshow', data);
      }
    }, {
      key: "onHide",
      value: function onHide(params) {
        var data = params || {};
        mop_bridge.subscribe('pageonhide', data);
      }
    }, {
      key: "onUnload",
      value: function onUnload(params) {
        var data = params || {};
        mop_bridge.webSubscribe('pageonunload', data);
      }
      /**
       * H5 调用原生方法
       * @param {String} name
       * @param {Object} params
       * @param {Funciton} callback
       */

    }, {
      key: "callNativeAPI",
      value: function callNativeAPI(name, params, callback) {
        mop_bridge.invoke(name, params, callback);
      }
      /**
       * 注册 H5 方法供原生调用
       * @param {String} name
       * @param {Function} handler
       */

    }, {
      key: "registNativeAPIHandler",
      value: function registNativeAPIHandler(name, handler) {
        mop_bridge.webSubscribe(name, handler);
      }
      /**
       * 监听小程序发送的事件
       * @param {*} handler
       */

    }, {
      key: "onWebviewEvent",
      value: function onWebviewEvent(handler) {
        if (typeof handler === 'function') {
          eventHandlers.push(handler);
        }
      }
      /**
       * 移除监听小程序发送的事件
       * @param {*} handler
       */

    }, {
      key: "offWebviewEvent",
      value: function offWebviewEvent(handler) {
        if (typeof handler === 'function') {
          eventHandlers = eventHandlers.filter(function (f) {
            return f !== handler;
          });
        }
      }
      /**
       * 触发 webview 标签绑定的 bindevent 方法
       * @param {*} data
       */

    }, {
      key: "sendWebviewEvent",
      value: function sendWebviewEvent(data) {
        mop_bridge.publish('onWebviewEvent', {
          key: 'sendEvent',
          params: data
        });
      }
    }]);

    return MOPClient;
  }();

  var MOPClientInstance = new MOPClient();
  window.subscribeHandler = mop_bridge.subscribeHandler;
  window.fc = {
    miniProgram: MOPClientInstance
  };
  window.ft = window.fc;
  window.addEventListener('message', function (e) {
    try {
      var _JSON$parse = JSON.parse(e.data),
          callbackId = _JSON$parse.callbackId,
          params = _JSON$parse.params;

      window.FinChatJSBridge.webInvokeCallbackHandler(callbackId, params);
    } catch (e) {}
  }, false);

  return MOPClientInstance;

}));
//# sourceMappingURL=js-sdk.js.map
